=== debian/changelog ===
biboumi (5.0-2) unstable; urgency=medium

  * Fix build with option -DCMAKE_BUILD_TYPE=Release.
    Closes: Bug#866225. Thanks to Florent Le Coz.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 28 Jun 2017 20:26:57 +0200

biboumi (5.0-1) unstable; urgency=medium

  [ upstream ]
  * New release.
    + Add identd server.
    + Add persistent option for channels, to behave like an IRC bouncer.
    + Use udns library (not c-ares) for asynchronous DNS resolution.
    + Update MAM implementation to version 6.0 (namespace mam:2).
    + Limit MAM to 100 messages per channel by default.
    + Properly handle multiline topics.
    + Support overriding configuration options by environment values.
    + Support customizing Botan TLS policies per IRC server.
    + IRC channel config form now available via MUC config.
    + Notices starting with "#channel" now treated as welcome messages.

  [ Jonas Smedegaard ]
  * Declare compliance with Debian Policy 4.0.0.
  * Modernize Vcs-Browser field:
    + Use git (not cgit) in path.
  * Update package relations:
    + Build-depend on libudns-dev (not libc-ares-dev).
    + Build-depend on libgcrypt20-dev.
    + Stop build-depend on libbotan1.10-dev (unused: Too old).
  * Drop patch 2002: Fixed upstream.
  * Unfuzz patch 2001.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 24 Jun 2017 10:15:23 +0200

biboumi (4.3-1) unstable; urgency=medium

  [ upstream ]
  * New release(s).
    + Works with botan 2.x (not only botan 1.11.x).
    + Fix build without LiteSQL available.
    + Fix segmentation fault connecting to IRC server on undefined port.

  [ Jonas Smedegaard ]
  * Update watch file:
    + Fix mangle upstream filename (lacked versioning, confusing uscan).
  * Modernize cdbs:
    + Do copyright-check in maintainer script (not during build).
    + Stop build-depend on licensecheck.
  * Drop patch cherry-picked upstream and now applied.
  * Drop patch cherry-picked upstream but now mysteriously gone from
    upstream master branch.
  * Update copyright info:
    + Extend copyright for my parts to cover current year.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 21 May 2017 12:03:04 +0200

biboumi (4.0-2) unstable; urgency=medium

  * Fix set proper group (and explicitly set user too, while at it).
    Closes: Bug#854252. Thanks to Jonas Wielicki and Florent Le Coz.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 04 Mar 2017 20:37:49 +0100
