=== debian/control ===
--- 
+++ 
@@ -4,7 +4,6 @@
 Build-Depends: cdbs,
  debhelper,
  dh-buildinfo,
- licensecheck,
  cmake,
  catch,
  uuid-dev,
@@ -12,14 +11,14 @@
  libexpat1-dev,
  libidn11-dev,
  libsystemd-dev,
- libc-ares-dev,
- libbotan1.10-dev
+ libudns-dev,
+ libgcrypt20-dev
 Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Jonas Smedegaard <dr@jones.dk>,
  Vasudev Kamath <vasudev@copyninja.info>
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Git: https://anonscm.debian.org/git/pkg-voip/biboumi.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-voip/biboumi.git
+Vcs-Browser: https://anonscm.debian.org/git/pkg-voip/biboumi.git
 Homepage: https://lab.louiz.org/louiz/biboumi/
 
 Package: biboumi
