## biboumi 7.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,8 +2,8 @@
 
 project(biboumi)
 
-set(${PROJECT_NAME}_VERSION_MAJOR 5)
-set(${PROJECT_NAME}_VERSION_MINOR 0)
+set(${PROJECT_NAME}_VERSION_MAJOR 7)
+set(${PROJECT_NAME}_VERSION_MINOR 2)
 set(${PROJECT_NAME}_VERSION_SUFFIX "")
 
 if(NOT CMAKE_BUILD_TYPE)
@@ -14,13 +14,13 @@
 #
 ## Find optional instrumentation libraries that will be used in debug only
 #
-find_library(LIBASAN NAMES asan libasan.so.3 libasan.so.2 libasan.so.1)
+find_library(LIBASAN NAMES asan libasan.so.4 libasan.so.3 libasan.so.2 libasan.so.1)
 find_library(LIBUBSAN NAMES ubsan libubsan.so.0)
 
 #
 ## Set various debug flags (instrumentation libs, coverage, …)
 #
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++1y -pedantic -Wall -Wextra -Wconversion")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++1y -pedantic -Wall -Wextra -Wconversion -fvisibility=hidden -fvisibility-inlines-hidden")
 if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
   set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fprofile-arcs -ftest-coverage --coverage")
 endif()
@@ -124,10 +124,16 @@
   find_package(UDNS)
 endif()
 
-if(WITH_LITESQL)
-  find_package(LITESQL REQUIRED)
-elseif(NOT WITHOUT_LITESQL)
-  find_package(LITESQL)
+if(WITH_SQLITE3)
+  find_package(SQLITE3 REQUIRED)
+elseif(NOT WITHOUT_SQLITE3)
+  find_package(SQLITE3)
+endif()
+
+if(WITH_POSTGRESQL)
+  find_package(PQ REQUIRED)
+elseif(NOT WITHOUT_POSTGRESQL)
+  find_package(PQ)
 endif()
 
 #
@@ -158,17 +164,14 @@
 file(GLOB source_utils
         src/utils/*.[hc]pp)
 add_library(utils OBJECT ${source_utils})
-add_dependencies(utils litesql_generated_sources)
 
 file(GLOB source_irc
         src/irc/*.[hc]pp)
 add_library(irc OBJECT ${source_irc})
-add_dependencies(irc litesql_generated_sources)
 
 file(GLOB source_xmpp
         src/xmpp/*.[hc]pp)
 add_library(xmpp OBJECT ${source_xmpp})
-add_dependencies(xmpp litesql_generated_sources)
 
 file(GLOB source_identd
         src/identd/*.[hc]pp)
@@ -177,7 +180,6 @@
 file(GLOB source_bridge
         src/bridge/*.[hc]pp)
 add_library(bridge OBJECT ${source_bridge})
-add_dependencies(bridge litesql_generated_sources)
 
 file(GLOB source_config
         src/config/*.[hc]pp)
@@ -191,20 +193,23 @@
         src/network/*.[hc]pp)
 add_library(network OBJECT ${source_network})
 
-if(LITESQL_FOUND)
-  LITESQL_GENERATE_CPP("database/database.xml"
-          "biboudb"
-          LITESQL_GENERATED_SOURCES)
-  add_custom_target(litesql_generated_sources SOURCES ${LITESQL_GENERATED_SOURCES})
-
-  add_library(database OBJECT src/database/database.cpp ${LITESQL_GENERATED_SOURCES})
-  add_dependencies(database litesql_generated_sources)
-
-  include_directories(database ${LITESQL_INCLUDE_DIRS})
+option(DEBUG_SQL_QUERIES
+       "If set to true, every SQL statement executed will be logged and timed"
+       OFF)
+if(SQLITE3_FOUND OR PQ_FOUND)
+  file(GLOB source_database
+          src/database/*.[hc]pp)
+  add_library(database OBJECT ${source_database})
+
+  if(SQLITE3_FOUND)
+    include_directories(database ${SQLITE3_INCLUDE_DIRS})
+  endif()
+  if(PQ_FOUND)
+    include_directories(database ${PQ_INCLUDE_DIRS})
+  endif()
   set(USE_DATABASE TRUE)
 else()
   add_library(database OBJECT "")
-  add_custom_target(litesql_generated_sources)
 endif()
 
 #
@@ -269,8 +274,14 @@
   target_link_libraries(test_suite ${LIBIDN_LIBRARIES})
 endif()
 if(USE_DATABASE)
-  target_link_libraries(${PROJECT_NAME} ${LITESQL_LIBRARIES})
-  target_link_libraries(test_suite ${LITESQL_LIBRARIES})
+  if(SQLITE3_FOUND)
+    target_link_libraries(${PROJECT_NAME} ${SQLITE3_LIBRARIES})
+    target_link_libraries(test_suite ${SQLITE3_LIBRARIES})
+  endif()
+  if(PQ_FOUND)
+    target_link_libraries(${PROJECT_NAME} ${PQ_LIBRARIES})
+    target_link_libraries(test_suite ${PQ_LIBRARIES})
+endif()
 endif()
 
 # Define a __FILENAME__ macro with the relative path (from the base project directory)
@@ -368,7 +379,3 @@
 add_custom_target(rpm
   DEPENDS dist
   COMMAND mkdir -p rpmbuild/{BUILD,RPMS,SOURCES,SPECS,SRPMS}
-  COMMAND rpmbuild --define "_topdir `pwd`/rpmbuild/" --define "_sourcedir `pwd`" -ba biboumi.spec
-  )
-
-#
