=== debian/changelog ===
biboumi (7.2-1) unstable; urgency=medium

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Fix ship with empty dir /var/lib/biboumi to get it removed on purge.
    Closes: Bug#886932. Thanks to Andreas Beckmann.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 01 Feb 2018 20:03:54 +0100

biboumi (7.1-1) unstable; urgency=medium

  [ upstream ]
  * New release(s).
    Closes: Bug#887838. Thanks to W. Martin Borgert.

  [ Jonas Smedegaard ]
  * Update package relations: Build-depend on libpq-dev.
  * Add patch 1001 to tighten shell code.
  * Install sqlite dumb script as example script.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 23 Jan 2018 11:29:57 +0100

biboumi (6.1-1) unstable; urgency=medium

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Update copyright info:
    + Fix update list of cmake files in the public-domain.
      Closes: Bug#877536. Thanks to Florent Le Coz <louiz@louiz.org>.
  * Build with user/group _biboumi, and create account in postinst:
    Newly enabled SQlite support requires a real home.
    Closes: 877533. Thanks to Vasudev Kamath and Florent Le Coz.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 04 Oct 2017 23:58:22 +0200

biboumi (6.0-1) unstable; urgency=medium

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Update package relations: Build-depend on libsqlite3-dev.
  * Unfuzz patch 2001.
  * Declare compliance with Debian Policy 4.1.1.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 30 Sep 2017 01:30:26 +0200

biboumi (5.0-3) unstable; urgency=medium

  * Have binary package provide virtual package ident-server.
  * Fix watch file.
  * Declare compliance with Debian Policy 4.1.0.
  * Tighten lintian overrides regarding License-Reference.
  * Advertise DEP3 format in patch headers.
  * Update copyright info: Fix include License section BSD-3-clause.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 14 Sep 2017 14:50:39 +0200
