=== debian/control ===
--- 
+++ 
@@ -4,19 +4,21 @@
 Build-Depends: cdbs,
  debhelper,
  dh-buildinfo,
- cmake,
- catch,
- uuid-dev,
- pandoc,
  libexpat1-dev,
  libidn11-dev,
  libsystemd-dev,
  libudns-dev,
- libgcrypt20-dev
+ libgcrypt20-dev,
+ libsqlite3-dev,
+ libpq-dev,
+ cmake,
+ catch,
+ uuid-dev,
+ pandoc
 Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Jonas Smedegaard <dr@jones.dk>,
  Vasudev Kamath <vasudev@copyninja.info>
-Standards-Version: 4.0.0
+Standards-Version: 4.1.1
 Vcs-Git: https://anonscm.debian.org/git/pkg-voip/biboumi.git
 Vcs-Browser: https://anonscm.debian.org/git/pkg-voip/biboumi.git
 Homepage: https://lab.louiz.org/louiz/biboumi/
@@ -24,7 +26,9 @@
 Package: biboumi
 Architecture: any
 Depends: ${misc:Depends},
- ${shlibs:Depends}
+ ${shlibs:Depends},
+ adduser,
+Provides: ident-server
 Description: XMPP gateway to connect to IRC servers
  Biboumi is an XMPP gateway that connects to IRC servers and translates
  between the two protocols. It can be used to access IRC channels using
