=== debian/rules ===
--- 
+++ 
@@ -23,13 +23,15 @@
 pkg = $(DEB_SOURCE_PACKAGE)
 
 # TODO: Build-dpend on libbotan1.11-dev or libbotan2.0 when available
-dev-deps = expat1 idn11 systemd udns gcrypt20
-CDBS_BUILD_DEPENDS += , cmake, catch, uuid-dev, pandoc
-CDBS_BUILD_DEPENDS += , $(patsubst %,$(comma) lib%-dev,$(dev-deps))
+dev-bdeps = expat1 idn11 systemd udns gcrypt20 sqlite3 pq
+bdeps = $(patsubst %,$(comma) lib%-dev,$(dev-bdeps))
+bdeps +=, cmake, catch, uuid-dev, pandoc
+
+CDBS_BUILD_DEPENDS +=, $(bdeps)
 
 DEB_CMAKE_EXTRA_FLAGS = \
  -DCMAKE_BUILD_TYPE=Release \
- -DSERVICE_USER=nobody -DSERVICE_GROUP=nogroup \
+ -DSERVICE_USER=_biboumi -DSERVICE_GROUP=_biboumi \
  -DBOTAN_LIBRARIES="$(shell pkg-config botan-1.10 --libs-only-L)" \
  -DBOTAN_INCLUDE_DIRS="$(shell pkg-config botan-1.10 --cflags-only-I)"
 
@@ -37,7 +39,10 @@
 
 DEB_INSTALL_CHANGELOGS_ALL += CHANGELOG.rst
 DEB_INSTALL_DOCS_$(pkg) += README.rst CONTRIBUTING.rst
-DEB_INSTALL_EXAMPLES_$(pkg) = doc/example.conf
+DEB_INSTALL_EXAMPLES_$(pkg) = doc/example.conf scripts/*
+
+# Create empty dir to have it removed on purge - see bug#886932
+DEB_INTALL_DIRS_$(pkg) = /var/lib/biboumi
 
 binary-post-install/$(pkg)::
 	mkdir -p $(cdbs_curdestdir)/lib
