=== debian/watch ===
# run "uscan --report" to check or "gpb import-orig --uscan" to update
version=4
opts="filenamemangle=s%/louiz/biboumi/repository/@ANY_VERSION@/archive(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
https://lab.louiz.org/louiz/biboumi/tags \
 /louiz/biboumi/repository/@ANY_VERSION@/archive@ARCHIVE_EXT@
