## biboumi 8.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,9 +2,19 @@
 
 project(biboumi)
 
-set(${PROJECT_NAME}_VERSION_MAJOR 7)
-set(${PROJECT_NAME}_VERSION_MINOR 2)
+set(${PROJECT_NAME}_VERSION_MAJOR 8)
+set(${PROJECT_NAME}_VERSION_MINOR 3)
 set(${PROJECT_NAME}_VERSION_SUFFIX "")
+
+if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
+    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5.0)
+        message(FATAL_ERROR "GCC version must be at least 5.0.")
+    endif()
+elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
+    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.4)
+        message(FATAL_ERROR "Clang version must be at least 3.4.")
+    endif()
+endif()
 
 if(NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE "Debug" CACHE STRING
@@ -308,7 +318,7 @@
 ExternalProject_Get_Property(catch SOURCE_DIR)
 if(NOT EXISTS ${CMAKE_SOURCE_DIR}/tests/catch.hpp)
   target_include_directories(test_suite
-    PUBLIC "${SOURCE_DIR}/include/"
+    PUBLIC "${SOURCE_DIR}/single_include/"
     )
   add_dependencies(test_suite catch)
 endif()
@@ -368,14 +378,3 @@
   # Remove a potential existing archive
   COMMAND rm -f ${CMAKE_CURRENT_BINARY_DIR}/${ARCHIVE_NAME}.tar.xz
   # Compress the archive
-  COMMAND xz ${CMAKE_CURRENT_BINARY_DIR}/${ARCHIVE_NAME}.tar
-  COMMAND ${CMAKE_COMMAND} -E cmake_echo_color --cyan "${ARCHIVE_NAME}.tar.xz created."
-  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
-  )
-add_custom_target(dist
-  DEPENDS ${ARCHIVE_NAME}.tar.xz
-  DEPENDS catch)
-
-add_custom_target(rpm
-  DEPENDS dist
-  COMMAND mkdir -p rpmbuild/{BUILD,RPMS,SOURCES,SPECS,SRPMS}
