=== debian/changelog ===
biboumi (8.3-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Dominik George <natureshadow@debian.org>  Mon, 22 Oct 2018 13:07:00 +0200

biboumi (8.3-1) unstable; urgency=medium

  [ upstream ]
  * New release(s).

  [ Jonas Smedegaard ]
  * Fix typo in watch file usage comment.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 20 Jun 2018 22:40:30 +0200

biboumi (8.0-1) unstable; urgency=medium

  [ upstream ]
  * New release.

  [ Dominik George ]
  * Remove empty /usr/lib from package.

  [ Jonas Smedegaard ]
  * Update watch file:
    + Fix typo in usage comment.
    + Update download pattern.
  * Modernize cdbs: Stop resolve build-dependencies in rules file.
  * Update package relations:
    + Tighten to Build-depend (explicitly and) versioned on gcc.
  * Update Vcs-* fields: Source hosted at Salsa.debian.org now.
  * Declare compliance with Debian Policy 4.1.4.
  * Unfuzz patch 2001.
  * Add patch 1002 to allow identd with systemd.
    Closes: Bug#895944. Thanks to Dominik George.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 07 May 2018 16:42:16 +0200

biboumi (7.2-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Dominik George <natureshadow@debian.org>  Sun, 15 Apr 2018 22:56:59 +0200

biboumi (7.2-2) unstable; urgency=medium

  * Update package relations:
    + Build-depend on libbotan-2-dev (not libgcrypt20-dev).
      Closes: Bug#857658. Thanks to Michel Le Bihan.
  * Drop custom (and wrong) Botan-related build options.

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 02 Mar 2018 01:09:42 +0100

biboumi (6.1-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports. (Closes: #872562)

 -- W. Martin Borgert <debacle@debian.org>  Mon, 01 Jan 2018 12:09:00 +0000
