=== debian/control ===
--- 
+++ 
@@ -4,11 +4,12 @@
 Build-Depends: cdbs,
  debhelper,
  dh-buildinfo,
+ gcc (>= 4:5),
  libexpat1-dev,
  libidn11-dev,
  libsystemd-dev,
  libudns-dev,
- libgcrypt20-dev,
+ libbotan-2-dev,
  libsqlite3-dev,
  libpq-dev,
  cmake,
@@ -17,10 +18,11 @@
  pandoc
 Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders: Jonas Smedegaard <dr@jones.dk>,
- Vasudev Kamath <vasudev@copyninja.info>
-Standards-Version: 4.1.1
-Vcs-Git: https://anonscm.debian.org/git/pkg-voip/biboumi.git
-Vcs-Browser: https://anonscm.debian.org/git/pkg-voip/biboumi.git
+ Vasudev Kamath <vasudev@copyninja.info>,
+ Dominik George <natureshadow@debian.org>
+Standards-Version: 4.1.4
+Vcs-Git: https://salsa.debian.org/pkg-voip-team/biboumi.git
+Vcs-Browser: https://salsa.debian.org/pkg-voip-team/biboumi
 Homepage: https://lab.louiz.org/louiz/biboumi/
 
 Package: biboumi
