=== debian/watch ===
# run "uscan --report" to check or "gbp import-orig --uscan" to update
version=4
https://lab.louiz.org/louiz/biboumi/tags \
 /louiz/biboumi/-/archive/[^/]+/biboumi@ANY_VERSION@@ARCHIVE_EXT@
